# Generated by go2rpm 1.6.0
%bcond_without check

# https://github.com/ent/ent
%global goipath         entgo.io/ent
%global forgeurl        https://github.com/ent/ent
Version:                0.10.0

%gometa

# this was previously golang-github-facebook-ent
%global goaltipaths     github.com/facebook/ent

%global common_description %{expand:
An entity framework for Go.}

%global golicenses      LICENSE
%global godocs          doc examples README.md README_jp.md\\\
                        CODE_OF_CONDUCT.md CONTRIBUTING.md README_zh.md\\\
                        entc/integration/README.md doc

Name:           %{goname}
Release:        %autorelease
Summary:        An entity framework for Go

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source:         %{gosource}

# multiple tests have 32-bit issues, upstream does not test on it
ExcludeArch:    %{ix86}

BuildRequires:  golang(github.com/go-openapi/inflect)
BuildRequires:  golang(github.com/google/uuid)
BuildRequires:  golang(github.com/gorilla/websocket)
BuildRequires:  golang(github.com/json-iterator/go)
BuildRequires:  golang(github.com/mattn/go-sqlite3)
BuildRequires:  golang(github.com/mitchellh/mapstructure)
BuildRequires:  golang(github.com/modern-go/reflect2)
BuildRequires:  golang(github.com/olekukonko/tablewriter)
BuildRequires:  golang(github.com/pkg/errors)
BuildRequires:  golang(github.com/spf13/cobra)
BuildRequires:  golang(go.opencensus.io/stats)
BuildRequires:  golang(go.opencensus.io/stats/view)
BuildRequires:  golang(go.opencensus.io/tag)
BuildRequires:  golang(go.opencensus.io/trace)
BuildRequires:  golang(golang.org/x/sync/errgroup)
BuildRequires:  golang(golang.org/x/sync/semaphore)
BuildRequires:  golang(golang.org/x/tools/go/packages)
BuildRequires:  golang(golang.org/x/tools/imports)

%if %{with check}
# Tests
BuildRequires:  golang(github.com/DATA-DOG/go-sqlmock)
# BuildRequires:  golang(github.com/google/uuid)
# BuildRequires:  golang(github.com/gorilla/websocket)
BuildRequires:  golang(github.com/jessevdk/go-flags)
BuildRequires:  golang(github.com/json-iterator/go)
# BuildRequires:  golang(github.com/modern-go/reflect2)
BuildRequires:  golang(github.com/stretchr/testify/assert)
BuildRequires:  golang(github.com/stretchr/testify/mock)
BuildRequires:  golang(github.com/stretchr/testify/require)
BuildRequires:  golang(golang.org/x/tools/go/packages/packagestest)
# BuildRequires:  golang(go.opencensus.io/stats/view)
# BuildRequires:  golang(go.opencensus.io/trace)
%endif

# goimport fails to pick up these
# _build/src/entgo.io/ent/dialect/sql/schema/atlas.go:15:2: cannot find package "ariga.io/atlas/sql/migrate" in any of:
#         /usr/lib/golang/src/ariga.io/atlas/sql/migrate (from $GOROOT)
#         /builddir/build/BUILD/ent-0.10.1/_build/src/ariga.io/atlas/sql/migrate (from $GOPATH)
#         /usr/share/gocode/src/ariga.io/atlas/sql/migrate
# _build/src/entgo.io/ent/dialect/sql/schema/mysql.go:20:2: cannot find package "ariga.io/atlas/sql/mysql" in any of:
#         /usr/lib/golang/src/ariga.io/atlas/sql/mysql (from $GOROOT)
#         /builddir/build/BUILD/ent-0.10.1/_build/src/ariga.io/atlas/sql/mysql (from $GOPATH)
#         /usr/share/gocode/src/ariga.io/atlas/sql/mysql
# _build/src/entgo.io/ent/dialect/sql/schema/postgres.go:19:2: cannot find package "ariga.io/atlas/sql/postgres" in any of:
#         /usr/lib/golang/src/ariga.io/atlas/sql/postgres (from $GOROOT)
#         /builddir/build/BUILD/ent-0.10.1/_build/src/ariga.io/atlas/sql/postgres (from $GOPATH)
#         /usr/share/gocode/src/ariga.io/atlas/sql/postgres
# _build/src/entgo.io/ent/dialect/sql/schema/atlas.go:16:2: cannot find package "ariga.io/atlas/sql/schema" in any of:
#         /usr/lib/golang/src/ariga.io/atlas/sql/schema (from $GOROOT)
#         /builddir/build/BUILD/ent-0.10.1/_build/src/ariga.io/atlas/sql/schema (from $GOPATH)
#         /usr/share/gocode/src/ariga.io/atlas/sql/schema
# _build/src/entgo.io/ent/dialect/sql/schema/sqlite.go:19:2: cannot find package "ariga.io/atlas/sql/sqlite" in any of:
#         /usr/lib/golang/src/ariga.io/atlas/sql/sqlite (from $GOROOT)
#         /builddir/build/BUILD/ent-0.10.1/_build/src/ariga.io/atlas/sql/sqlite (from $GOPATH)
#         /usr/share/gocode/src/ariga.io/atlas/sql/sqlite
BuildRequires:  golang(ariga.io/atlas/sql/migrate)
BuildRequires:  golang(ariga.io/atlas/sql/mysql)
BuildRequires:  golang(ariga.io/atlas/sql/postgres)
BuildRequires:  golang(ariga.io/atlas/sql/schema)
BuildRequires:  golang(ariga.io/atlas/sql/sqlite)

# and these
# BuildRequires:  golang(github.com/golang-migrate/migrate/v4)

%description
%{common_description}

%gopkg

%prep
%goprep

%generate_buildrequires
# %%go_generate_buildrequires

%build
for cmd in cmd/ent* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

%if %{with check}
%check
# remove failing tests
rm entc/internal/snapshot_test.go
rm entc/load/load_test.go
%gocheck
%endif

%files
%license LICENSE
%doc doc examples README.md README_jp.md CODE_OF_CONDUCT.md CONTRIBUTING.md
%doc README_zh.md entc/integration/README.md doc
%{_bindir}/*

%gopkgfiles

%changelog
%autochangelog
